/**
 * An activity that is for reading news
 */
package com.kvnallsn.militarynews;

import android.app.TabActivity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.os.Bundle;
import android.widget.TabHost;
import android.widget.TabHost.OnTabChangeListener;

/**
 * @author Kevin Allison
 *
 */
public class NewsActivity extends TabActivity {

	private TabHost tabHost;
	
	public void onCreate(Bundle icicle) {
		getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
		super.onCreate(icicle);
        setContentView(R.layout.tab_layout);	
		
        ServiceInfo.tabsActive = true;
        
		Resources res = this.getResources();
		tabHost = this.getTabHost();
		TabHost.TabSpec spec; 
		Intent intent;
		
		// Create intent to launch next activity -- News
		if (ServiceInfo.serviceCode == ServiceInfo.SAVEDITEMS) {
			intent = new Intent().setClass(this, SavedReader.class).putExtra("type", ServiceInfo.READ_NEWS);
		} else {
			intent = new Intent().setClass(this, NewsReader.class);
		}
		spec = tabHost.newTabSpec("RSS Reader").setIndicator("News", res.getDrawable(R.drawable.news_tab)).setContent(intent);
		tabHost.addTab(spec);
		
		// Create another tab -- Twitter
		if (ServiceInfo.serviceCode == ServiceInfo.SAVEDITEMS) {
			intent = new Intent().setClass(this, SavedReader.class).putExtra("type", ServiceInfo.TWITTER);
		} else {
			intent = new Intent().setClass(this, TwitterReader.class);
		}
		spec = tabHost.newTabSpec("Twitter").setIndicator("Twitter", res.getDrawable(R.drawable.twitter_tab)).setContent(intent);
		tabHost.addTab(spec);
		
		// No Blog for the Marines!
		// Need to fix Naval Blog -- no RSS feed, but blog exists
		if (ServiceInfo.serviceCode != ServiceInfo.MARINES) { 
			// Create another tab -- Blog
			if (ServiceInfo.serviceCode == ServiceInfo.SAVEDITEMS) {
				intent = new Intent().setClass(this, SavedReader.class).putExtra("type", ServiceInfo.BLOG);	
			} else {
				intent = new Intent().setClass(this, BlogReader.class);
			}
			spec = tabHost.newTabSpec("Blog").setIndicator("Blog", res.getDrawable(R.drawable.blog_tab)).setContent(intent);
			tabHost.addTab(spec);
		}
			
		// Create another tab -- YouTube
		if (ServiceInfo.serviceCode == ServiceInfo.SAVEDITEMS) {
			intent = new Intent().setClass(this, SavedReader.class).putExtra("type", ServiceInfo.YOUTUBE);	
		} else {
			intent = new Intent().setClass(this, YoutubeReader.class);
		}
		spec = tabHost.newTabSpec("Videos").setIndicator("Videos", res.getDrawable(R.drawable.youtube_tab)).setContent(intent);
		tabHost.addTab(spec);
		
        // Load preferences
        SharedPreferences settings = getSharedPreferences(ServiceInfo.getPrefsName(), 0);
		tabHost.setCurrentTab(settings.getInt("favTab", 0));
		
		// Set tab changed listener
		tabHost.setOnTabChangedListener( new OnTabChangeListener() {
			public void onTabChanged(String tabId) {
				if ("Twitter".equals(tabId)) {
					//ServiceInfo.newsOption = ServiceInfo.TWITTER;
				} else if ("Blog".equals(tabId)) {
					//ServiceInfo.newsOption = ServiceInfo.BLOG;
				} else if ("Youtube".equals(tabId)) {
					//ServiceInfo.newsOption = ServiceInfo.YOUTUBE;
				} else {
					//ServiceInfo.newsOption = ServiceInfo.READ_NEWS;
				}
			}
		});
	}
	
	@Override
	public void onDestroy() {
		ServiceInfo.tabsActive = false;
		super.onDestroy();
	}
}