/**
 * Dummy class for reading the news
 */
package com.kvnallsn.militarynews;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.Toast;

/**
 * @author Kevin Allison
 *
 */
public class NewsReader extends RSSReader {

	/*
	 * (non-Javadoc)
	 * @see com.kvnallsn.militarynews.RSSReader#onCreate(android.os.Bundle)
	 */
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		//ServiceInfo.newsOption = ServiceInfo.READ_NEWS;
		
        // Load preferences
        SharedPreferences settings = getSharedPreferences(ServiceInfo.getPrefsName(), 0);
		int newsNum = settings.getInt("newsSource", 1);
		
		registerForContextMenu(lView);	
		new FetchFeed().execute(ServiceInfo.getNewsSource(newsNum), ServiceInfo.getServiceName() + "News.tmp", "Skip");
	}
	
	/*
	 * (non-Javadoc)
	 * @see android.app.Activity#onCreateContextMenu(android.view.ContextMenu, android.view.View, android.view.ContextMenu.ContextMenuInfo)
	 */
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo info) {
		super.onCreateContextMenu(menu, v, info);
		//menu.add(0, READ_MORE, 0, "View related articles");
	}
	
	public boolean onCreateOptionsMenu(Menu menu) {
	    menu.add(0, NEWS_SOURCE, 0, "Select News Source").setIcon(R.drawable.source);
	    return super.onCreateOptionsMenu(menu);
	}
	
	/*
	 * (non-Javadoc)
	 * @see android.app.Activity#onContextItemSelected(android.view.MenuItem)
	 */
	public boolean onContextItemSelected(MenuItem item) {
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
		switch (item.getItemId()) {
		case READ_MORE:
			System.out.println(feed.getItem((int)info.id)._title);
			//new ViewMore().execute(feed.getItem((int)info.id)._description);
			return true;
		case SAVE:
			RSSItem newsItem = feed.getItem(info.position);
			ServiceInfo app = (ServiceInfo) NewsReader.this.getApplication();
			app.dbLayer.open();
			if (app.dbLayer.addItem(DatabaseLayer.NEWS_TABLE, newsItem._title, newsItem._pubDate, newsItem._link, "", ServiceInfo.getPrefsName())) {
				Toast.makeText(this, "Article successfully saved.", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(this, "Article is already saved.", Toast.LENGTH_SHORT).show();
			}
			app.dbLayer.close();
			return true;
		}
		return super.onContextItemSelected(item);
	}
	
	protected class ViewMore extends AsyncTask<String, Void, String> {

		@Override
		protected String doInBackground(String... params) {
			// Parse Description for link
			
			int linkLoc = params[0].lastIndexOf("http://");
			int endLoc = params[0].indexOf('\"', linkLoc);
			String link = params[0].substring(linkLoc, endLoc);
			link = link.replace("&amp;", "&");
			link = link + "&output=rss";
			return link;
		}
		
		@Override
		protected void onPostExecute(String link) {
			Intent itemIntent = new Intent(NewsReader.this, ReadMore.class);
			itemIntent.putExtra("url", link);
			startActivity(itemIntent);
		}		
	}
}
