/**
 * Represent an RSS Item
 */
package com.kvnallsn.militarynews;

import java.net.MalformedURLException;
import java.net.URL;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * @author Kevin Allison
 *
 */
public class RSSItem implements Parcelable{

	public String _title = null;
	public String _description = null;
	public String _link = null;
	public String _category = null;
	public String _pubDate = null; 
	public URL _imageURL = null;
	public String _author = null;
	
	
	public static final Parcelable.Creator<RSSItem> CREATOR = new Parcelable.Creator<RSSItem>() {

		public RSSItem createFromParcel(Parcel in) {
			return new RSSItem(in);
		}

		public RSSItem[] newArray(int arg0) {
			// TODO Auto-generated method stub
			return null;
		}
		
	};

	/*
	 * Empty constructor
	 */
	RSSItem() {
		
	}
	
	/*
	 * Constructor to create an RSSItem from a parcel
	 */
	RSSItem(Parcel in) {
		_title = in.readString();
		_pubDate = in.readString();
		_description = in.readString();
		_link = in.readString();
		_category = in.readString();
	}
	
	public int describeContents() {
		return 0;
	}

	public void writeToParcel(Parcel out, int flags) {
		out.writeString(_title);
		out.writeString(_pubDate);
		out.writeString(_description);
		out.writeString(_link);
		out.writeString(_category);
	}
	
	void setTitle(String title) {
		_title = title;
	}
	
	void setDescription(String desc) {
		_description = desc;
	}
	
	void setLink(String link) {
		_link = link;
	}
	
	void setCategory(String cat) {
		_category = cat;
	}
	
	void setPubDate(String pubDate) {
		_pubDate = pubDate;
	}
	
	void setImageURL(String url) {
		try {
			_imageURL = new URL(url);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}
	
	String getTitle() {
		return _title;
	}
	
	String getDescription() {
		return _description;
	}
	
	String getLink() {
		return _link;
	}
	
	String getCategory() {
		return _category;
	}
	
	String getPubDate() {
		return _pubDate;
	}
	
	URL getImageUrl() {
		return _imageURL;
	}
	
	public String toString() {
		// Limit amount of text to display
		if (_title.length() > 42) {
			return _title.substring(0,42) + "...";
		}
		return _title;
	}
}
