/**
 * Read an RSS feeds description
 */
package com.kvnallsn.militarynews;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.webkit.WebView;
import android.widget.TextView;
import android.widget.Toast;

/**
 * @author Kevin Allison
 *
 */
public class ReadDesc extends Activity {

	/*
	 * @Override
	 * Called when the activity is created
	 */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.desc);
		
		Intent startingIntent = getIntent();
		RSSItem item = null;
		
		if (startingIntent != null) {
			Bundle b = startingIntent.getBundleExtra("android.intent.extra.INTENT");
			if (b == null) {
				Toast.makeText(this, "Error Retreiving Service Information: Error 1", Toast.LENGTH_LONG).show();
			} else {
				item = (RSSItem) b.getParcelable("item");
			}
		} else {
			Toast.makeText(this, "Error Retreiving Service Information: Error 2", Toast.LENGTH_LONG).show();
		}
		
		TextView title = (TextView) findViewById(R.id.descTitle);
		title.setText(item.getTitle());
		
		TextView date = (TextView) findViewById(R.id.descDate);
		date.setText(item.getPubDate());
		
		WebView content = (WebView) findViewById(R.id.descContent);
		// Replace characters to make code URI-escaped
		String desc = item.getDescription().replace("#", "%23").replace("%", "%25").replace("\\", "%27").replace("?", "%3f");
		content.loadData(desc, "text/html", "utf-8");
	}
}
